<div align="center">
    <img width=15% alt="JARVIS" src="https://git.zevaryx.com/stark-industries/jarvis/jarvis-bot/-/raw/main/jarvis_small.png">

# Just Another Rather Very Intelligent System

<br />

[![python 3.10+](https://img.shields.io/badge/python-3.10+-blue)]()
[![tokei lines of code](https://tokei.rs/b1/gitlab/zevaryx/jarvis-bot?category=code)](https://git.zevaryx.com/stark-industries/jarvis/jarvis-bot)
[![discord chat widget](https://img.shields.io/discord/862402786116763668?style=social&logo=discord)](https://discord.gg/VtgZntXcnZ)

[![ko-fi](https://www.ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/zevaryx)

### Welcome to the JARVIS Initiative, an open-source multi-purpose bot

</div>

## Features

JARVIS currently offers:

- 👩‍💼 **Administration**: `verify`, `ban/unban`, `kick`, `purge`, `mute/unmute` and more!
- 🚓 **Moderation**: `lock/unlock`, `lockdown`, `warn`, `autoreact`, and also more!
- 🔧 **Utilities**: `remindme`, `rolegiver`, `temprole`, `image`, and so many more!
- 🏷️ **Tags**: Custom `tag`s! Useful for custom messages without the hassle!

## Contributing

Before **creating an issue**, please ensure that it hasn't already been reported/suggested.
If you have a question, please join the community Discord before opening an issue.

If you wish to contribute to the JARVIS codebase or documentation, join the Discord! The recognized developers there will help you get started.

## Community

Join the [Stark R&D Department Discord server](https://discord.gg/VtgZntXcnZ) to be kept up-to-date on code updates and issues.

## Requirements

- MongoDB 7.0 or higher
- Python 3.12 or higher
- [tokei](https://github.com/XAMPPRocky/tokei) 12.1 or higher
- Everything in `requirements.txt`

## JARVIS Features

### Core Features

- Reminders!
  - Set a reminder using human wording
  - Use cron to have it repeat!
  - Copy reminders that other users make so that you can also be reminded of it
- Server, User, and Role info!
- List all the emotes in the server!
- Check the bot status and see the logo!
- Secure password generation!
- Timestamp conversions!

### Admin Features

- Track administrative actions taken against users!
  - Bans, mutes, and more!
  - Custom warnings
  - Moderation cases
- Warn for pinging too many people/specific roles!
- Server lockdowns to help with raids/spam
- Custom filters to prevent certain messages/phrases!
- Automated purging of channels
- Verification system

### Extra Features

- Calculator!
  - Calculate basic math expressions
  - Convert to and from many different units
    - All conversions supported by the Microsoft calculator are supported!
  - Live currency conversions
- Developer Tools!
  - Hash using any Python-supported hash function!
    - You can even hash URLs and uploads!
  - Base-n encoding and decoding!
  - Unique ID generation via ULIDs, UUIDs, and ObjectIDs!
- Image processing!
  - Shrink an image to fit a certain size! Useful for making emotes
- Pinboard!
  - Run out of pins? Use the pinboard!
  - Dedicated channel for pinning messages
- Rolegiver!
  - Advanced self-assigned roles
  - Group together roles for better organization!
- Tags!
  - Custom text responses from the bot
  - Editing can be done by the author or a moderator!
